VTK: vtkOpenGLRenderUtilities Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkOpenGLRenderUtilities Class Reference

OpenGL rendering utility functions. More...

`#include <vtkOpenGLRenderUtilities.h>`

Inheritance diagram for vtkOpenGLRenderUtilities:
[legend]
Collaboration diagram for vtkOpenGLRenderUtilities:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkOpenGLRenderUtilities * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenGLRenderUtilities * | SafeDownCast (vtkObjectBase *o)
static bool | PrepFullScreenVAO (vtkOpenGLBufferObject *vertBuf, vtkOpenGLVertexArrayObject *vao, vtkShaderProgram *prog)
static void | MarkDebugEvent (const std::string &event)
| Pass a debugging mark to the render engine to assist development via tools like apitrace. More...
static void | RenderQuad (float *verts, float *tcoords, vtkShaderProgram *program, vtkOpenGLVertexArrayObject *vao)
| Helper function that draws a quad on the screen at the specified vertex coordinates and if tcoords are not NULL with the specified texture coordinates. More...
static void | RenderTriangles (float *verts, unsigned int numVerts, GLuint *iboData, unsigned int numIndices, float *tcoords, vtkShaderProgram *program, vtkOpenGLVertexArrayObject *vao)
| Helper function that draws a quad on the screen at the specified vertex coordinates and if tcoords are not NULL with the specified texture coordinates. More...
static std::string | GetFullScreenQuadVertexShader ()
| Draw a full-screen quad: More...
static std::string | GetFullScreenQuadFragmentShaderTemplate ()
| Draw a full-screen quad: More...
static std::string | GetFullScreenQuadGeometryShader ()
| Draw a full-screen quad: More...
static bool | PrepFullScreenVAO (vtkOpenGLRenderWindow *renWin, vtkOpenGLVertexArrayObject *vao, vtkShaderProgram *prog)
| Draw a full-screen quad: More...
static void | DrawFullScreenQuad ()
| Draw a full-screen quad: More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkOpenGLRenderUtilities ()
| ~vtkOpenGLRenderUtilities () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

OpenGL rendering utility functions.

vtkOpenGLRenderUtilities provides functions to help render primitives.

See also the vtkOpenGLQuadHelper class which may be easier to use.

Tests:
  vtkOpenGLRenderUtilities (Tests)

Definition at line 31 of file vtkOpenGLRenderUtilities.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkOpenGLRenderUtilities::Superclass

Definition at line 34 of file vtkOpenGLRenderUtilities.h.

## Constructor & Destructor Documentation

## ◆ vtkOpenGLRenderUtilities()

vtkOpenGLRenderUtilities::vtkOpenGLRenderUtilities | ( |  | ) |
| protected

## ◆ ~vtkOpenGLRenderUtilities()

vtkOpenGLRenderUtilities::~vtkOpenGLRenderUtilities | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkOpenGLRenderUtilities::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkOpenGLRenderUtilities::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkOpenGLRenderUtilities* vtkOpenGLRenderUtilities::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkOpenGLRenderUtilities::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkOpenGLRenderUtilities* vtkOpenGLRenderUtilities::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkOpenGLRenderUtilities::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ RenderQuad()

static void vtkOpenGLRenderUtilities::RenderQuad | ( | float * | verts,
|  | float * | tcoords,
|  | vtkShaderProgram * | program,
|  | vtkOpenGLVertexArrayObject * | vao
| ) |  |
| static

Helper function that draws a quad on the screen at the specified vertex coordinates and if tcoords are not NULL with the specified texture coordinates.

## ◆ RenderTriangles()

static void vtkOpenGLRenderUtilities::RenderTriangles | ( | float * | verts,
|  | unsigned int | numVerts,
|  | GLuint * | iboData,
|  | unsigned int | numIndices,
|  | float * | tcoords,
|  | vtkShaderProgram * | program,
|  | vtkOpenGLVertexArrayObject * | vao
| ) |  |
| static

Helper function that draws a quad on the screen at the specified vertex coordinates and if tcoords are not NULL with the specified texture coordinates.

## ◆ GetFullScreenQuadVertexShader()

static std::string vtkOpenGLRenderUtilities::GetFullScreenQuadVertexShader | ( |  | ) |
| static

Draw a full-screen quad:

- VertexShader and GeometryShader should be used as-is when building the ShaderProgram.
- FragmentShaderTemplate supports the replacements
  //VTK::FSQ::Decl
  and
  //VTK::FSQ::Impl
  for declaring variables and the shader body, respectively.
- The varying texCoord is available to the fragment shader for texture lookups into full-screen textures, ie. texture2D(textureName, texCoord).
- PrepFullScreenVAO initializes a new VAO for drawing a quad.
- DrawFullScreenQuad actually draws the quad.

Example usage:

typedef vtkOpenGLRenderUtilities GLUtil;
// Prep fragment shader source:
std::string fragShader = GLUtil::GetFullScreenQuadFragmentShaderTemplate();
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Decl",
"uniform sampler2D aTexture;");
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Impl",
"gl_FragData[0] = texture2D(aTexture, texCoord);");
// Create shader program:
vtkShaderProgram *prog = shaderCache->ReadyShaderProgram(
GLUtil::GetFullScreenQuadVertexShader().c_str(),
fragShader.c_str(),
GLUtil::GetFullScreenQuadGeometryShader().c_str());
// Initialize new VAO/vertex buffer. This is only done once:
vtkNew<vtkOpenGLVertexArrayObject> vao;
GLUtil::PrepFullScreenVAO(renWin, vao.Get(), prog);
// Setup shader program to sample vtkTextureObject aTexture:
aTexture->Activate();
prog->SetUniformi("aTexture", aTexture->GetTextureUnit());
// Render the full-screen quad:
vao->Bind();
GLUtil::DrawFullScreenQuad();
vao->Release();
aTexture->Deactivate();
vtkNew
Allocate and hold a VTK object.
Definition: vtkNew.h:60
vtkNew::Get
T * Get() const noexcept
Get a raw pointer to the contained object.
Definition: vtkNew.h:150
vtkOpenGLRenderUtilities
OpenGL rendering utility functions.
Definition: vtkOpenGLRenderUtilities.h:32
vtkShaderProgram
The ShaderProgram uses one or more Shader objects.
Definition: vtkShaderProgram.h:47
vtkShaderProgram::SetUniformi
bool SetUniformi(const char *name, int v)
Set the name uniform value to int v.
vtkShaderProgram::Substitute
static bool Substitute(std::string &source, const std::string &search, const std::string &replace, bool all=true)
perform in place string substitutions, indicate if a substitution was done this is useful for buildin...
vtkX3D::string
@ string
Definition: vtkX3D.h:490

## ◆ GetFullScreenQuadFragmentShaderTemplate()

static std::string vtkOpenGLRenderUtilities::GetFullScreenQuadFragmentShaderTemplate | ( |  | ) |
| static

Draw a full-screen quad:

- VertexShader and GeometryShader should be used as-is when building the ShaderProgram.
- FragmentShaderTemplate supports the replacements
  //VTK::FSQ::Decl
  and
  //VTK::FSQ::Impl
  for declaring variables and the shader body, respectively.
- The varying texCoord is available to the fragment shader for texture lookups into full-screen textures, ie. texture2D(textureName, texCoord).
- PrepFullScreenVAO initializes a new VAO for drawing a quad.
- DrawFullScreenQuad actually draws the quad.

Example usage:

typedef vtkOpenGLRenderUtilities GLUtil;
// Prep fragment shader source:
std::string fragShader = GLUtil::GetFullScreenQuadFragmentShaderTemplate();
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Decl",
"uniform sampler2D aTexture;");
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Impl",
"gl_FragData[0] = texture2D(aTexture, texCoord);");
// Create shader program:
vtkShaderProgram *prog = shaderCache->ReadyShaderProgram(
GLUtil::GetFullScreenQuadVertexShader().c_str(),
fragShader.c_str(),
GLUtil::GetFullScreenQuadGeometryShader().c_str());
// Initialize new VAO/vertex buffer. This is only done once:
vtkNew<vtkOpenGLVertexArrayObject> vao;
GLUtil::PrepFullScreenVAO(renWin, vao.Get(), prog);
// Setup shader program to sample vtkTextureObject aTexture:
aTexture->Activate();
prog->SetUniformi("aTexture", aTexture->GetTextureUnit());
// Render the full-screen quad:
vao->Bind();
GLUtil::DrawFullScreenQuad();
vao->Release();
aTexture->Deactivate();

## ◆ GetFullScreenQuadGeometryShader()

static std::string vtkOpenGLRenderUtilities::GetFullScreenQuadGeometryShader | ( |  | ) |
| static

Draw a full-screen quad:

- VertexShader and GeometryShader should be used as-is when building the ShaderProgram.
- FragmentShaderTemplate supports the replacements
  //VTK::FSQ::Decl
  and
  //VTK::FSQ::Impl
  for declaring variables and the shader body, respectively.
- The varying texCoord is available to the fragment shader for texture lookups into full-screen textures, ie. texture2D(textureName, texCoord).
- PrepFullScreenVAO initializes a new VAO for drawing a quad.
- DrawFullScreenQuad actually draws the quad.

Example usage:

typedef vtkOpenGLRenderUtilities GLUtil;
// Prep fragment shader source:
std::string fragShader = GLUtil::GetFullScreenQuadFragmentShaderTemplate();
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Decl",
"uniform sampler2D aTexture;");
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Impl",
"gl_FragData[0] = texture2D(aTexture, texCoord);");
// Create shader program:
vtkShaderProgram *prog = shaderCache->ReadyShaderProgram(
GLUtil::GetFullScreenQuadVertexShader().c_str(),
fragShader.c_str(),
GLUtil::GetFullScreenQuadGeometryShader().c_str());
// Initialize new VAO/vertex buffer. This is only done once:
vtkNew<vtkOpenGLVertexArrayObject> vao;
GLUtil::PrepFullScreenVAO(renWin, vao.Get(), prog);
// Setup shader program to sample vtkTextureObject aTexture:
aTexture->Activate();
prog->SetUniformi("aTexture", aTexture->GetTextureUnit());
// Render the full-screen quad:
vao->Bind();
GLUtil::DrawFullScreenQuad();
vao->Release();
aTexture->Deactivate();

## ◆ PrepFullScreenVAO() [1/2]

static bool vtkOpenGLRenderUtilities::PrepFullScreenVAO | ( | vtkOpenGLRenderWindow * | renWin,
|  | vtkOpenGLVertexArrayObject * | vao,
|  | vtkShaderProgram * | prog
| ) |  |
| static

Draw a full-screen quad:

- VertexShader and GeometryShader should be used as-is when building the ShaderProgram.
- FragmentShaderTemplate supports the replacements
  //VTK::FSQ::Decl
  and
  //VTK::FSQ::Impl
  for declaring variables and the shader body, respectively.
- The varying texCoord is available to the fragment shader for texture lookups into full-screen textures, ie. texture2D(textureName, texCoord).
- PrepFullScreenVAO initializes a new VAO for drawing a quad.
- DrawFullScreenQuad actually draws the quad.

Example usage:

typedef vtkOpenGLRenderUtilities GLUtil;
// Prep fragment shader source:
std::string fragShader = GLUtil::GetFullScreenQuadFragmentShaderTemplate();
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Decl",
"uniform sampler2D aTexture;");
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Impl",
"gl_FragData[0] = texture2D(aTexture, texCoord);");
// Create shader program:
vtkShaderProgram *prog = shaderCache->ReadyShaderProgram(
GLUtil::GetFullScreenQuadVertexShader().c_str(),
fragShader.c_str(),
GLUtil::GetFullScreenQuadGeometryShader().c_str());
// Initialize new VAO/vertex buffer. This is only done once:
vtkNew<vtkOpenGLVertexArrayObject> vao;
GLUtil::PrepFullScreenVAO(renWin, vao.Get(), prog);
// Setup shader program to sample vtkTextureObject aTexture:
aTexture->Activate();
prog->SetUniformi("aTexture", aTexture->GetTextureUnit());
// Render the full-screen quad:
vao->Bind();
GLUtil::DrawFullScreenQuad();
vao->Release();
aTexture->Deactivate();

## ◆ DrawFullScreenQuad()

static void vtkOpenGLRenderUtilities::DrawFullScreenQuad | ( |  | ) |
| static

Draw a full-screen quad:

- VertexShader and GeometryShader should be used as-is when building the ShaderProgram.
- FragmentShaderTemplate supports the replacements
  //VTK::FSQ::Decl
  and
  //VTK::FSQ::Impl
  for declaring variables and the shader body, respectively.
- The varying texCoord is available to the fragment shader for texture lookups into full-screen textures, ie. texture2D(textureName, texCoord).
- PrepFullScreenVAO initializes a new VAO for drawing a quad.
- DrawFullScreenQuad actually draws the quad.

Example usage:

typedef vtkOpenGLRenderUtilities GLUtil;
// Prep fragment shader source:
std::string fragShader = GLUtil::GetFullScreenQuadFragmentShaderTemplate();
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Decl",
"uniform sampler2D aTexture;");
vtkShaderProgram::Substitute(fragShader, "//VTK::FSQ::Impl",
"gl_FragData[0] = texture2D(aTexture, texCoord);");
// Create shader program:
vtkShaderProgram *prog = shaderCache->ReadyShaderProgram(
GLUtil::GetFullScreenQuadVertexShader().c_str(),
fragShader.c_str(),
GLUtil::GetFullScreenQuadGeometryShader().c_str());
// Initialize new VAO/vertex buffer. This is only done once:
vtkNew<vtkOpenGLVertexArrayObject> vao;
GLUtil::PrepFullScreenVAO(renWin, vao.Get(), prog);
// Setup shader program to sample vtkTextureObject aTexture:
aTexture->Activate();
prog->SetUniformi("aTexture", aTexture->GetTextureUnit());
// Render the full-screen quad:
vao->Bind();
GLUtil::DrawFullScreenQuad();
vao->Release();
aTexture->Deactivate();

## ◆ PrepFullScreenVAO() [2/2]

static bool vtkOpenGLRenderUtilities::PrepFullScreenVAO | ( | vtkOpenGLBufferObject * | vertBuf,
|  | vtkOpenGLVertexArrayObject * | vao,
|  | vtkShaderProgram * | prog
| ) |  |
| static

## ◆ MarkDebugEvent()

static void vtkOpenGLRenderUtilities::MarkDebugEvent | ( | const std::string & | event | ) |
| static

Pass a debugging mark to the render engine to assist development via tools like apitrace.

This calls glDebugMessageInsert to insert the event string into the OpenGL command stream.

Note that this method only works when glDebugMessageInsert is bound, which it may not be on certain platforms.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkOpenGLRenderUtilities.h